


 // cmn_defs.h: defs common to PC and PIC program
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no


// Commands from User ("frame type" field)
#define CMN_NOT_A_LEGAL_CMND 0x00

#define CMN_PROGRAM_EEPROM_CMND 0x0A
#define CMN_RESET_UC_CMND       0x14
#define CMN_RESET_EEP_CMND      0x15

#define CMN_TX1010TEST_CMND     0x1E

#define CMN_READ_EEP_CMND       0x28

#define CMN_USE_EEPROM_CMND     0x38
#define CMN_USE_FLASH_CMND      0x39
#define CMN_GET_SOURCE_CMND     0x3A
#define CMN_GET_FW_CMND         0x3B
#define CMN_GET_CWRD_CMND       0x3C

#define CMN_READ_FEE_CMND       0x40  // added 2004 09 23 PKB
#define CMN_TUNE_FEE_CMND       0x41

//Start field high and low ascii character
#define CMN_START_FIELD_HIGH '0'
#define CMN_START_FIELD_LOW  '0'

//Stop field, hex value
#define CMN_STOP_FIELD 0xFF

// Overhead for program EEPROM commands (not including the start field and the length field)
#define CMN_OVERHEAD_PROGRAM_EEPROM 0x04 // type, address, #bytes, stop


// Overhead for commands (not including the start field and the length field)
#define CMN_OVERHEAD_COMMANDS 0x02 // type, stop



//Absolute min and max value for "Frame Length"
#define CMN_MIN_LENGTH   CMN_OVERHEAD_COMMANDS
#define CMN_MAX_LENGTH  (CMN_OVERHEAD_PROGRAM_EEPROM + 22)
