


 //
 // RFPRG.C: Created 2004 03 17 
 //    505 eval project, RF-chip procedures for programming RF chip
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no

 
 
 // Program description: 
 //



 #define C_FILE        // Tested in "p18xxxx.h" (to include correct file for C/ASM - programs)
 #define RFPRG_FILE    //



//*************************************************
//
// Include files
//
//************************************************* 
 #include "p18def.h"   // Define PIC used
 #include "p18xxxx.h"  // Standard Microchip file for the selected PIC
 #include "c_subst.h"  // Common C substitutes
 
 #include "gen.h"      // General defs 
 #include "io_xxx.h"   // Input/output
 #include "rfprg.h"    //
 


//*************************************************
//
// Code starts here
//
//************************************************* 
 #pragma code
 #pragma udata


uint8
RFPRG_Get_Frequency( uint8 index)      
{
      switch( index) 
      {
	     case 0:
	        return(  0); //
	     case 1:
	        return(  1); //
	     case 2:
	        return(  2); //
	     case 3:
	        return(  3); //
	     case 4:
	        return(  1); // 
	     case 5:
	        return(  3); // 
	     case 6:
	        return(  2); //       
	     case 7:
	        return(  0); // 
	     case 8:
	        return(  2); //
	     case 9:
	        return(  3); //
	     case 10:
	        return(  0); //       
	     case 11:
	        return(  1); //
	     case 12:
	        return(  3); //
	     case 13:
	        return(  2); //
	     case 14:
	        return(  0); //      
	     case 15:
	        return(  1); //
	     case 16:
	        return(  0); // 
	     case 17:
	        return(  1); //
	     case 18:
	        return(  3); //      
	     case 19:
	        return(  2); //
	     case 20:
	        return(  3); //
	     case 21:
	        return(  2); //
	     case 22:
	        return(  0); //
	     case 23:
	        return(  1); //
	     case 24:
	        return(  3); //      	        	        
      }  
}





void
RFPRG_Fill_Controlword( void)
{  
   union
   {
      struct
      {
         uint16 all;
      };
      struct
      {
         uint8 low;
         uint8 high;
      };
   }  help_A,
      help_N;
 	
   if( not RFPRG_CNTRWRD_FILLED_FLAG) // Controlword may be filled already (by main program) 
   {
      RFPRG_Fill_Default_Controlword();

      if( RFPRG_ENTER_TX_FLAG)
      {
         RFPRG_Prog_Buffer[ 0x00].all = ChxxWrd0x00t;
      }
      else
      {
         RFPRG_Prog_Buffer[ 0x00].all = ChxxWrd0x00r;
      }
      
      if( not RFPRG_FREQ_FOUND_FLAG) // If flag set, then use the value already in RFPRG_Frequency
      {
         RFPRG_Frequency = RFPRG_Get_Frequency( RFPRG_FreqIndex); // else: find the wanted value
      }

      help_A.low = A_CH00;

      if( RFPRG_Frequency == (uint8)1)
      {
         help_A.low = A_CH01;
      }
      if( RFPRG_Frequency == (uint8)2)
      {
         help_A.low = A_CH02;
      }
      if( RFPRG_Frequency == (uint8)3)
      {
         help_A.low = A_CH03;
      }


      RFPRG_Prog_Buffer[ 0x0A].all = help_A.low;
      RFPRG_Prog_Buffer[ 0x0B].all = Ch00Wrd0x0B;
      RFPRG_Prog_Buffer[ 0x0C].all = Ch00Wrd0x0C;
      RFPRG_Prog_Buffer[ 0x0D].all = Ch00Wrd0x0D;
      RFPRG_Prog_Buffer[ 0x0E].all = Ch00Wrd0x0E;
   
      RFPRG_Prog_Buffer[ 0x0F].all = help_A.low;
      RFPRG_Prog_Buffer[ 0x10].all = Ch00Wrd0x10;
      RFPRG_Prog_Buffer[ 0x11].all = Ch00Wrd0x11;
      RFPRG_Prog_Buffer[ 0x12].all = Ch00Wrd0x12;
      RFPRG_Prog_Buffer[ 0x13].all = Ch00Wrd0x13;   

      RFPRG_CNTRWRD_FILLED_FLAG = 1;
   }
}




void
RFPRG_Enter_Rx( void)
{
   RFPRG_ENTER_TX_FLAG = 0;
   RFPRG_Program_Rf();
}


void
RFPRG_Enter_Tx( void)
{
   RFPRG_ENTER_TX_FLAG = 1;
   RFPRG_Program_Rf();
}



void
RFPRG_Program_Rf( void)
{
   union
   {
      struct 
      {
         uint8 all;
      };
      struct 
      {
          unsigned bit0:1;
          unsigned bit1:1;
          unsigned bit2:1;
          unsigned bit3:1;
          unsigned bit4:1;
          unsigned bit5:1;
          unsigned bit6:1;
          unsigned bit7:1;
       };
   } RFPRG_Temp0,
     RFPRG_Temp1,
     RFPRG_Temp2;

   RFPRG_Fill_Controlword(); // Fill the wanted controlword into buffer (if not filled by main program)

   RFPRG_Desktop.all      = RFPRG_Prog_Buffer[ 0x00].all; // New value to fill into desktop register

   RFPRG_Help_Desktop.all = RFPRG_Desktop.all; // 
   RFPRG_Help_Desktop.PA  = 0;                 // Make help_desktop = new desktop with PA=0
   RFPRG_Prog_Buffer[ 0x00].all = RFPRG_Help_Desktop.all;

   RF_CS = 1;
   RFPRG_Rf_Write( 0,22);  // Start writing from address 0, write 22 bytes of the controlword

   RFPRG_Temp0.all  = INTCON;
   INTCON           = 0;        // Make sure no interrupt occurs 
   RF_CS            = 0;
   RF_DATA_TRIS     = 1;        // Set DATAIXO as input 
   RF_DATA_SDO_TRIS = 1;        // (DATAIXO connected to > 1 pin)
   INTCON           = RFPRG_Temp0.all;

   if( ( RFPRG_Desktop.Mode == (uint8)3) and ( RFPRG_Desktop.PA != (uint8)0) ) // Turn PA on
   {
      RF_CS = 1;
      RFPRG_Prog_Buffer[ 0x00].all = RFPRG_Desktop.all ; // PA on-setting
      RFPRG_Rf_Write( 0,1);  // Start writing from address 0, write 1 byte of the controlword

      RFPRG_Wait_Lock();      // Wait for lock (LD == 1 or waited > x usecs)

      RF_CS = 0; // This will generate a new loadpulse
   }

   RFPRG_Wait_Lock();      // Wait for lock (LD == 1 or waited > x usecs)
  
   RFPRG_Desktop.all = RFPRG_Prog_Buffer[ 0x00].all;
   RFPRG_CNTRWRD_FILLED_FLAG = 0; // Clear flag for controlword filled 
}




// Returns when
//    1) LD detected going from low to high, or
//    2) LD "stuck" high for xusec or
//    3) LD "stuck" low for y msec ( in this case, RFchip is not in lock!)
// Note: If going from power-down or standby into rx or tx, then the timeouts may not be sufficient!
//       (in this case, include delay in calling procedure)
// Note: PLL lock time is a function of the PLL loop filter
//       Loop filter is selected based on bitrate
//       A higher bitrate gives a filter with higher bandwith
//       A higher bandwith gives a shorter PLL lock time 
void
RFPRG_Wait_Lock( void)
{
   uint8 in_lock,
         quit_lock;

   in_lock   = 0;
   quit_lock = 0;

   // Initiate tmr0 for 800 usec timeout ("Timeout1")
   do
   {
      T0CON = 0;
      TMR0  = 118; // 11.0592MHz xtal => timeout = 800 usec (pre 1:16 => count 16*(256-118) = 16*138 times )
  
      INTCONbits.TMR0IE = 0;
      INTCONbits.TMR0IF = 0;
      T0CON = 0b11010011; // TMR0 on, 8-bit, prescaler 1:16

      while( ( not in_lock) and ( RF_LD)) // If LD "stuck" on until Timeout1, or LD detected low: quit
      {
         if( INTCONbits.TMR0IF)
         {
            in_lock = 0xFF; // LD "stuck" ON until Timeout1, LD is valid
         }
      }
   
      if( not RF_LD) // LD detected low
      {
         //Initiate tmr0 for 8 msec (approx) timeout ("Timeout2")
         T0CON =   0;
         TMR0  = 170; // 11.0592MHz xtal => timeout = 8 msec (pre 1:256 => count 256*(256-170) times = 22016 (22016*4/11.0592e6 => 8msec)  )
         INTCONbits.TMR0IE = 0;
         INTCONbits.TMR0IF = 0;
         T0CON = 0b11010111; // TMR0 on, 8-bit, prescaler 1:256

         while( ( not quit_lock) and ( not RF_LD)) // If LD "stuck" OFF until Timeout2, or LD going from OFF to ON: quit
         {
            if( INTCONbits.TMR0IF)
            {
               quit_lock = 0xFF; // Lock detect is not found! Abort procedure
            }
         }

         if( RF_LD)         //!!!!! note: returns asap if LD detected low, then high
         {                  //!!!!!
            in_lock = 0xFF; //!!!!!
         }                  //!!!!!

      }
   } while( ( not in_lock) and ( not quit_lock)); // wait until LD deteteced high for timeout1, or low for timeout2
   
   T0CON = 0;
   TMR0  = 0;
   INTCONbits.TMR0IF = 0;
}

/*
void
RFPRG_Delay_256( void)
{
    RFPRG_Delay_64();
    RFPRG_Delay_64();
    RFPRG_Delay_64();
    RFPRG_Delay_64();
}

void
RFPRG_Delay_64( void)
{
    RFPRG_Delay_16();
    RFPRG_Delay_16();
    RFPRG_Delay_16();
    RFPRG_Delay_16();
}

void
RFPRG_Delay_16( void)
{
   RFPRG_Delay_4();
   RFPRG_Delay_4();
   RFPRG_Delay_4();
   RFPRG_Delay_4();
}
*/

void
RFPRG_Delay_4( void)
{
}


/*
// delay = delaytime*timeout
//  
// Count instructions, do not change timers
void
RFPRG_Delay( uint8 delaytime)
{
   uint8  to_counter;

   to_counter = delaytime;

   while( to_counter)
   {
      RFPRG_Delay_256(); // Count approx 256 instr. If 11.0592 => 92.6 usec
      to_counter--;
   }  
}
*/




// Pre: RFPRG_Prog_Buffer holds bytes to write
void
RFPRG_Rf_Write( uint8 write_address, uint8 nr_of_bytes)
{
   static uint8 i,
                j;

   RFPRG_Write_Byte( (write_address<<1)+0); //address is 7 msb, r/w-bit(lsb) = 0 for write
   
   j = nr_of_bytes;
   i = 0;
   
   while( j)
   {
      RFPRG_Write_Byte( RFPRG_Prog_Buffer[ i].all);   
      i++;
      j--;
   }
}



// Post: RFPRG_Prog_Buffer holds the read bytes
void
RFPRG_Rf_Read( uint8 read_address, uint8 nr_of_bytes)
{
   static uint8 i,
                j;

   RF_CS = 1;
   
   RFPRG_Write_Byte( (read_address<<1)+1); //address is 7 msb, r/w-bit(lsb) = 1 for read
   
   j = nr_of_bytes;
   i = 0;
   
   RF_IO_TRIS = 1; // Make sure IO is input
      
   while( j)
   {
      RFPRG_Prog_Buffer[ i].all = RFPRG_Read_Byte();   
      i++;
      j--;
   }
   
   RF_CS = 0;
   Nop();
   RF_IO_TRIS = 0; // Make sure IO is output again
}



void
RFPRG_Write_Byte( uint8 byte_to_write)
{
   static uint8 temp;
      
   temp = 0x80;     

   while( temp)
   {
      if( byte_to_write bit_and temp)   
      {
         RF_IO_OUT = 1;
      }
      else   
      {
         RF_IO_OUT = 0;
      }
      RFPRG_Delay_4();
      RF_SCLK = 1;   //
      RF_SCLK = 0;   //    
      temp  >>= 1;   // 
   }
}   



uint8
RFPRG_Read_Byte( void)
{
   static uint8 temp,
                read_byte;
   
   read_byte = 0x00;
   temp      = 0x80;
   
   while( temp)
   {
      RF_SCLK = 1;     //
      RF_SCLK = 0;     //
      RFPRG_Delay_4(); //
      if( RF_IO_IN)
      {
         read_byte += temp;
      }
      temp >>= 1;
   }      
         
   return( read_byte);
}                                                   
   


/*
// Enter tx on the rx-frequency
// used when txing  a carrier
// Pre: RFPRG_Freqreg=freq number to enter
// Note: Does not make any delays for PA ON or LOCK
void
RFPRG_Enter_Tx_Rxfreq( void)
{
   uint8 help_reg;

   RFPRG_Enter_Rx();
   
   help_reg = (RFPRG_Prog_Buffer[ 0x00].all) bit_or 0b01110110; // Make sure Mode = tx and PA = max
   RFPRG_Prog_Buffer[ 0x00].all = help_reg;  
   RFPRG_Rf_Write( 0,1); 
}
*/

void
RFPRG_Update_FreqIndex( void)
{
   RFPRG_FreqIndex++;              // Select next index  
   if( RFPRG_FreqIndex > (uint8)24)  // Select 00..24
   {
      RFPRG_FreqIndex = 0x00;
   } 
}



void
RFPRG_Fill_Default_Controlword( void)
{
 //RFPRG_Prog_Buffer[ 0x00].all = ChxxWrd0x00; // Default word

   RFPRG_Prog_Buffer[ 0x01].all = ChxxWrd0x01;
   RFPRG_Prog_Buffer[ 0x02].all = ChxxWrd0x02;
   RFPRG_Prog_Buffer[ 0x03].all=  ChxxWrd0x03;
   RFPRG_Prog_Buffer[ 0x04].all = ChxxWrd0x04;
   
   RFPRG_Prog_Buffer[ 0x05].all = ChxxWrd0x05;
   RFPRG_Prog_Buffer[ 0x06].all = ChxxWrd0x06;
   RFPRG_Prog_Buffer[ 0x07].all = ChxxWrd0x07;
   RFPRG_Prog_Buffer[ 0x08].all = ChxxWrd0x08;
   RFPRG_Prog_Buffer[ 0x09].all = ChxxWrd0x09;
   
 //RFPRG_Prog_Buffer[ 0x0A].all = Ch00Wrd0x0A;
 //RFPRG_Prog_Buffer[ 0x0B].all = Ch00Wrd0x0B;
 //RFPRG_Prog_Buffer[ 0x0C].all = Ch00Wrd0x0C;
 //RFPRG_Prog_Buffer[ 0x0D].all = Ch00Wrd0x0D;
 //RFPRG_Prog_Buffer[ 0x0E].all = Ch00Wrd0x0E;
   
 //RFPRG_Prog_Buffer[ 0x0F].all = Ch00Wrd0x0F;
 //RFPRG_Prog_Buffer[ 0x10].all = Ch00Wrd0x10;
 //RFPRG_Prog_Buffer[ 0x11].all = Ch00Wrd0x11;
 //RFPRG_Prog_Buffer[ 0x12].all = Ch00Wrd0x12;
 //RFPRG_Prog_Buffer[ 0x13].all = Ch00Wrd0x13;
      
   RFPRG_Prog_Buffer[ 0x14].all = ChxxWrd0x14;
   RFPRG_Prog_Buffer[ 0x15].all = ChxxWrd0x15;
}

