


 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no



  #define not_used_val 0

// *****************************************************
//     433.92MHz band: f0=433.4MHz, f3=434.4MHz
//     Closed loop VCO mod NOTE!!!!!
//     38462 bauds 
//     Sallen key: 230KHz
//     Switched cap: 200kHz
//     Deviation: approx 90 kHz 
//     
// *****************************************************

// address 0x00
#define By_LNA_v  (0<<7)
#define PA2_v     (1<<6)
#define PA1_v     (1<<5)
#define PA0_v     (1<<4)
#define Sync_en_v (1<<3)
#define Mode1_v   (1<<2)
#define Mode0_v   (0<<1)
#define Load_en_v (1)

#define ChxxWrd0x00  ( By_LNA_v + PA2_v + PA1_v + PA0_v + Sync_en_v + Mode1_v + Mode0_v + Load_en_v) & 0x00FF 
#define ChxxWrd0x00r ( By_LNA_v + PA2_v + PA1_v + PA0_v + Sync_en_v + 4 + 0 + Load_en_v) & 0x00FF
#define ChxxWrd0x00t ( By_LNA_v + PA2_v + PA1_v + PA0_v + Sync_en_v + 4 + 2 + Load_en_v) & 0x00FF

// address 0x01
#define Modulation1_v    (0<<7)
#define Modulation0_v    (0<<6) //Closed loop VCO mod
#define OL_opamp_en_v    (0<<5) //NOTE!!!!! 
#define PA_LDc_en_v      (0<<4)
#define RSSI_en_v        (1<<3)
#define LD_en_v          (1<<2)
#define PF_FC1_v         (1<<1) //Sallen Key: 230kHz
#define PF_FC0_v         (0)

#define ChxxWrd0x01 ( Modulation1_v + Modulation0_v + OL_opamp_en_v + PA_LDc_en_v + RSSI_en_v + LD_en_v + PF_FC1_v + PF_FC0_v) & 0x00FF 


// address 0x02
#define CP_HI_v  (0<<7)
#define SC_by_v  (0<<6)
#define VCO_by_v (0<<5)
#define PA_by_v  (0<<4)
#define OUTS3_v  (0<<3)
#define OUTS2_v  (0<<2)
#define OUTS1_v  (0<<1)
#define OUTS0_v  (0)

#define ChxxWrd0x02 ( CP_HI_v + SC_by_v + VCO_by_v + PA_by_v + OUTS3_v + OUTS2_v + OUTS1_v + OUTS0_v) & 0x00FF 


// address 0x03
#define IFBias_s_v   (1<<7)
#define IFA_HG_v     (1<<6)
#define VCO_Bias_s_v (0<<5)
#define VCO_IB2_v    (1<<4) // VCO_IB: 434MHz setting
#define VCO_IB1_v    (0<<3)
#define VCO_IB0_v    (0<<2)
#define VCO_freq1_v  (1<<1) // VCO_freq: 434 MHz setting 
#define VCO_freq0_v  (0)

#define ChxxWrd0x03 ( IFBias_s_v + IFA_HG_v + VCO_Bias_s_v + VCO_IB2_v + VCO_IB1_v + VCO_IB0_v + VCO_freq1_v + VCO_freq0_v) & 0x00FF 


// address 0x04
#define Mod_F2_v    (0<<7) //MOD_F = 3
#define Mod_F1_v    (1<<6)
#define Mod_F0_v    (1<<5)
#define Mod_I4_v    (0<<4) //MOD_I = 2
#define Mod_I3_v    (0<<3)
#define Mod_I2_v    (0<<2)
#define Mod_I1_v    (1<<1)
#define Mod_I0_v    (0)


#define ChxxWrd0x04 ( Mod_F2_v + Mod_F1_v + Mod_F0_v + Mod_I4_v + Mod_I3_v + Mod_I2_v + Mod_I1_v + Mod_I0_v) & 0x00FF 


// address 0x05
#define A05B7_v       (not_used_val<<7)
#define A05B6_v       (not_used_val<<6)
#define Mod_FHG_v (0<<5)
#define Mod_shape (1<<4)
#define Mod_A3_v  (0<<3) //MOD_A = 0
#define Mod_A2_v  (0<<2)
#define Mod_A1_v  (0<<1)
#define Mod_A0_v  (0)

#define ChxxWrd0x05 ( A05B7_v + A05B6_v + Mod_FHG_v + Mod_shape + Mod_A3_v + Mod_A2_v + Mod_A1_v + Mod_A0_v) & 0x00FF 


// address 0x06
#define Demod_OS_v      (0<<7)
#define Mod_clkS2_v     (1<<6) //Mod_ClkS = 5
#define Mod_clkS1_v     (0<<5)
#define Mod_clkS0_v     (1<<4)
#define BitSync_clkS2_v (1<<3) //BitSync_clkS = 6
#define BitSync_clkS1_v (1<<2)
#define BitSync_clkS0_v (0<<1)
#define BitRate_clkS2_v (0) //BitRate_clkS = 2

#define ChxxWrd0x06 ( Demod_OS_v + Mod_clkS2_v + Mod_clkS1_v + Mod_clkS0_v + BitSync_clkS2_v + BitSync_clkS1_v + BitSync_clkS0_v + BitRate_clkS2_v) & 0x00FF 


// address 0x07
#define BitRate_clkS1_v (1<<7)
#define BitRate_clkS0_v (0<<6)
#define RefClk_K5_v     (0<<5) // RefClk_K = 13
#define RefClk_K4_v     (0<<4)
#define RefClk_K3_v     (1<<3)
#define RefClk_K2_v     (1<<2)
#define RefClk_K1_v     (0<<1)
#define RefClk_K0_v     (1)

#define ChxxWrd0x07 ( BitRate_clkS1_v + BitRate_clkS0_v + RefClk_K5_v + RefClk_K4_v + RefClk_K3_v + RefClk_K2_v + RefClk_K1_v + RefClk_K0_v) & 0x00FF 


// address 0x08
#define SC_HI_v    (1<<7)
#define ScClk_X2_v (0<<6) // SC cutoff = 200kHz
#define ScSW_en_v  (0<<5) // !!!!! different from 505 !!!!!
#define ScClk4_v   (0<<4) 
#define ScClk3_v   (0<<3)
#define ScClk2_v   (0<<2)
#define ScClk1_v   (0<<1)
#define ScClk0_v   (1)

#define ChxxWrd0x08 ( SC_HI_v + ScClk_X2_v + ScSW_en_v + ScClk4_v + ScClk3_v + ScClk2_v + ScClk1_v + ScClk0_v) & 0x00FF 


// address 0x09
#define PrescalMode_s_v (0<<7)
#define Prescal_s_v     (1<<6)
#define XCOAR_en_v      (1<<5)
#define XCOtune4_v      (1<<4) // XCOtune = 16
#define XCOtune3_v      (0<<3)
#define XCOtune2_v      (0<<2)
#define XCOtune1_v      (0<<1)
#define XCOtune0_v      (0)

#define ChxxWrd0x09 ( PrescalMode_s_v + Prescal_s_v + XCOAR_en_v + XCOtune4_v + XCOtune3_v + XCOtune2_v + XCOtune1_v + XCOtune0_v) & 0x00FF 


//address 0x0A-0x13: Dividers




// address 0x14
#define Div2_HI_v (1<<7)
#define LO_IB1_v  (0<<6)
#define LO_IB0_v  (1<<5)
#define PA_IB4_v  (0<<4) 
#define PA_IB3_v  (0<<3) 
#define PA_IB2_v  (0<<2)
#define PA_IB1_v  (1<<1)
#define PA_IB0_v  (1) 

#define ChxxWrd0x14 ( Div2_HI_v + LO_IB1_v + LO_IB0_v + PA_IB4_v + PA_IB3_v + PA_IB2_v + PA_IB1_v + PA_IB0_v) & 0x00FF 



// address 0x15
#define A15B7_v       (not_used_val<<7)
#define A15B6_v       (not_used_val<<6)
#define A15B5_v       (not_used_val<<5)
#define A15B4_v       (not_used_val<<4)
#define FEEC_3_v (0<<3)
#define FEEC_2_v (0<<2)
#define FEEC_1_v (0<<1)
#define FEEC_0_v (0)

#define ChxxWrd0x15 ( A15B7_v + A15B6_v + A15B5_v + A15B4_v + FEEC_3_v + FEEC_2_v + FEEC_1_v + FEEC_0_v) & 0x00FF 






// **********
// *** f0 ***
//***********

// 433.4MHz, 100kHz comp freq
// Dividers placed here:
#define M_CH00  160
#define A_CH00  7
#define N_CH00  559

#define A_CH01  19
#define A_CH02  35
#define A_CH03  47

#define Ch00Wrd0x0A  A_CH00       & 0x003F 
#define Ch00Wrd0x0B (N_CH00 >> 8) & 0x000F
#define Ch00Wrd0x0C  N_CH00       & 0x00FF 
#define Ch00Wrd0x0D (M_CH00 >> 8) & 0x000F  
#define Ch00Wrd0x0E  M_CH00       & 0x00FF 

#define Ch00Wrd0x0F  A_CH00       & 0x003F 
#define Ch00Wrd0x10 (N_CH00 >> 8) & 0x000F 
#define Ch00Wrd0x11  N_CH00       & 0x00FF 
#define Ch00Wrd0x12 (M_CH00 >> 8) & 0x000F  
#define Ch00Wrd0x13  M_CH00       & 0x00FF 

    


#ifdef RFPRG_FILE
 #pragma udata access RFPRG_regs_access
#else
 extern
#endif
volatile near union
   {
      struct 
      {
         uint8 all;
      };
      struct
      {
         unsigned  Load_en:1;
         unsigned  Mode:2;
         unsigned  Sync_en:1;
         unsigned  PA:3;
         unsigned  By_LNA:1;      
      };
       struct 
       {
          unsigned bit0:1;
          unsigned bit1:1;
          unsigned bit2:1;
          unsigned bit3:1;
          unsigned bit4:1;
          unsigned bit5:1;
          unsigned bit6:1;
          unsigned bit7:1;
       };
   } RFPRG_Desktop,
     RFPRG_Help_Desktop; 



   
   
   
#ifndef RFPRG_FILE 
extern
#endif 
volatile near union
   {
       struct
       {
           uint8  all;            
       };
       struct 
       {
          unsigned bit0:1;
          unsigned bit1:1;
          unsigned bit2:1;
          unsigned bit3:1;
          unsigned bit4:1;
          unsigned bit5:1;
          unsigned bit6:1;
          unsigned bit7:1;
       };
   } RFPRG_Flags;   
   
#define RFPRG_PA_ON_FLAG            RFPRG_Flags.bit0
#define RFPRG_ENTER_TX_FLAG         RFPRG_Flags.bit2
#define RFPRG_CNTRWRD_FILLED_FLAG   RFPRG_Flags.bit3 // set if the rf-controlword already filled into prog-buffer  
#define RFPRG_FREQ_FOUND_FLAG       RFPRG_Flags.bit4 // set if RFPRG_Frequency already holds the wanted frequency number

#ifndef RFPRG_FILE 
extern
#endif 
volatile near uint8 RFPRG_Frequency, // Actual frequency number
                    RFPRG_FreqIndex; // Index to use in a look-up table. 
                                     // Incremented in timer-interrupt if flag is set;
                                     // else it's controlled by background program



#pragma udata
#ifndef RFPRG_FILE
extern
#endif 
volatile union
   {
       struct
       {
           uint8  all;            
       };
       struct 
       {
          unsigned bit0:1;
          unsigned bit1:1;
          unsigned bit2:1;
          unsigned bit3:1;
          unsigned bit4:1;
          unsigned bit5:1;
          unsigned bit6:1;
          unsigned bit7:1;
       };
   } RFPRG_Prog_Buffer[ 22];



                    
#ifndef RFPRG_FILE
extern
#endif 
uint8 RFPRG_Get_Frequency( uint8 index);


#ifndef RFPRG_FILE
extern
#endif
void  RFPRG_Update_FreqIndex( void);



#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Enter_Tx( void);


#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Enter_Rx( void);


#ifndef RFPRG_FILE 
extern
#endif
void RFPRG_Program_Rf( void);


#ifndef RFPRG_FILE 
extern
#endif
void RFPRG_Fill_Controlword( void);


#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Wait_Lock( void);


#ifndef BCCPROG_FILE 
extern
#endif
void  RFPRG_Rf_Write( uint8 write_address, uint8 nr_of_bytes);


#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Rf_Read( uint8 read_address, uint8 nr_of_bytes);


#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Write_Byte( uint8 byte_to_write);


#ifndef RFPRG_FILE 
extern
#endif
uint8 RFPRG_Read_Byte( void);
   
/*
#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Enter_Tx_Rxfreq( void);
*/

#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Fill_Default_Controlword( void);

/*
#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Delay( uint8 delaytime);

#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Delay_256( void);

#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Delay_64( void);

#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Delay_16( void);
*/

#ifndef RFPRG_FILE 
extern
#endif
void  RFPRG_Delay_4( void);
