


 //
 // USART.H: Created 2003 03 18
 //    USART flags and constants, variables and prototypes (if any)
 //
 // (C) Micrel Norway AS
 //     Proprietary firmware of Micrel Norway AS
 //
 


 // Note: The intention of the firmware listed below is to help users 
 //       get hands-on experience with Micrel Norway's products.
 
 //       No guarantee is implied as to the suitableness of the firmware 
 //       in a given application.
 
 //       For further information, please contact post@micrel.no



//*************************************************
//
// Prototype declarations/Imported procedures
//
//*************************************************

#ifndef USART_FILE
extern
#endif
void USART_Output_Byte( uint8 usart_byte);

#ifndef USART_FILE
extern
#endif
void USART_Init( void);

#ifndef USART_FILE
extern
#endif
void USART_Start_Buffer_Out( void);

#ifndef USART_FILE
extern
#endif
void USART_Enable_Input_From_DTE( void);

#ifndef USART_FILE
extern
#endif
void USART_Disable_Input_From_DTE( void);

#ifndef USART_FILE
extern
#endif
uint8 USART_DTE_Ready_For_Input( void);

#ifndef USART_FILE
extern
#endif
void USART_TX_Int_Handler( void);

#ifndef USART_FILE
extern
#endif
void USART_RX_Int_Handler( void);



//*************************************************
//
// Constant values
//
//*************************************************

   #define USART_MAX_FROM_DTE  64 // Note!!!!
   #define USART_BUFFERSIZE    70


//*************************************************
//
// Flags and variables
//
//*************************************************

#ifdef USART_FILE
 #pragma udata access usart_regs_access
#else
 extern
#endif
volatile near union {
          struct {
             uint8 all;
          };
          struct {
             unsigned :1; //USART_OUT_ACTIVE:1;
             unsigned :1; //USART_IN_ACTIVE:1;
             unsigned :1; //GOT_INPUT:1;
             unsigned :1; 
             unsigned SKIP_HS:1;   
             unsigned :3;
          };
       } USART_Flags; 
       
 
 


#ifndef USART_FILE
 extern
#endif
volatile near uint8  USART_Out_Length,
                     USART_Out_Nextout,
                     USART_Out_Nextin,
                     USART_In_Length,
                     USART_In_Nextout,
                     USART_In_Nextin;

#pragma udata
#ifndef USART_FILE
 extern
#endif
volatile uint8 USART_In_Buffer[  USART_BUFFERSIZE],
               USART_Out_Buffer[ USART_BUFFERSIZE];
